class Management::ComplaintsController < ManagementController
  include RepositoriesProxy
  before_action :set_complaint, only: :destroy

  def index
    @complaints = Complaint.includes(:complaint_reason, :complaintable, :user)
  end

  def destroy
    Complaint.destroy @complaint

    respond_to do |format|
      format.html { redirect_to :back, notice: 'Denúncia excluída com sucesso.' }
    end
  end

  private

  def set_complaint
    @complaint = Complaint.find params[:id]
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def complaint_params
    params.require(:complaint).permit(:id, :complaintable_id, :complaintable_type, :complaint_reason_id, :description)
  end
end
