class Management::StatisticsController < ManagementController
  include RepositoriesProxy
  #before_action :set_statistics
  before_action :authenticate_user!, except: [:index, :show, :like]

  #inicialização, primeira query
  @@flag = 0

  def index
    #a cada novo login atualiza as estatísticas
    if @@flag == 0 || @@user != current_user
      @@user =  current_user
      set_statistics
      @@flag = 1
    end

    @n_users = @@n_users
    @n_collections = @@n_collections
    @n_non_visualised = @@n_non_visualised
    @n_learning_objects = @@n_learning_objects
    @total_accesses= User.sum("sign_in_count")
  end

  def users
    #missing roles
    @n_users = User.count
    @n_curators = Role.find_by(name: "curator").users.size
    @n_admins = Role.find_by(name: "admin").users.size
    @n_teachers = Role.find_by(name: "teacher").users.size
  end

  def accesses
    #usar o logstash e kibana
    #enquanto isso, uso o sign_in_count do ActiveRecord
    @total_accesses= User.sum("sign_in_count")


  end

  def collections
    if @@flag == 0 || @@user != current_user
      @@user =  current_user
      set_statistics
      @@flag = 1
    end
    @n_collections = @@n_collections || []
  end


  def learning_objects
    if @@flag == 0 || @@user != current_user
      @@user =  current_user
      @@flag = 1
      set_statistics
    end
    @n_learning_objects = @@n_learning_objects
    @most_visualised = @@most_visualised
    @n_non_visualised = @@n_non_visualised

  end


  def set_statistics
    @@n_users = User.count
    @@n_collections = Collection.all.size
    @@n_learning_objects = LearningObject.all.size
    @@n_non_visualised = LearningObject.where(views_count: 0).size
    @@most_visualised = LearningObject.order(:views_count)
    @@n_views = LearningObject.sum(:views_count)
   end

  def views

  end

end
